QGIS Application - Bug report #4437
DB-Manager: python error
2011-10-24 10:33 AM - aperi2007 -

Status: Closed

Priority: Normal

Assignee: Giuseppe Sucameli

Category: Python plugins

Affected QGIS version: Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution: invalid
Crashes QGIS or corrupts data: Copied to github as #: 14369
Description

Hi,

opening the db-manager plugin and try-ing to open a postgis connection,
| see this python error:

An error has occured while executing Python code:

Traceback (most recent call last):
File "C:/Users/peri/.qgis/python/plugins\\db_manager\\db_model.py", line 399, in rowCount
self._refreshindex( parent )
File "C:/Users/peri/.qgis/python/plugins\\db_manager\\db_model.py", line 443, in _refreshindex
if item.populate():
File "C:/Users/peri/.qgis/python/plugins\\db_manager\\db_model.py", line 158, in populate
schemas = connection.database().schemas()
File "C:/Users/peri/.qgis/python/plugins\\db_manager\\db_plugins\\plugin.py", line 222, in schemas
return map(lambda x: self.schemasFactory(x, self), schemas)
File "C:/Users/peri/.qgis/python/plugins\\db_manager\\db_ plugins\\plugin.py", line 222, in
return map(lambda x: self.schemasFactory(x, self), schemas)
File "C:/Users/peri/.qgis/python/plugins\\db_manager\\db_plugins\\postgis\\plugin.py", line 149, in schemasFactory
return PGSchema(row, db)
File "C:/Users/peri/.qgis/python/plugins\\db_manager\\db_ plugins\\postgis\\plugin.py", line 161, in __init___
self.tableCount = len(self.tables())
File "C:/Users/peri/.qgis/python/plugins\\db_manager\\db_plugins\\plugin.py", line 292, in tables
return self.database().tables(self)
File "C:/Users/peri/.qgis/python/plugins\\db_manager\\db_plugins\\plugin.py", line 251, in tables
tables = self.connector.getTables(schema.name if schema else None)
File "C:/Users/peri/.qgis/python/plugins\\db_manager\\db_plugins\\postgis\\connector.py", line 179, in getTables
rasters = self.getRasterTables(schema)
File "C:/Users/peri/.qgis/python/plugins\\db_manager\\db_plugins\\postgis\\connector.py", line 338, in getRasterTables
self._execute(c, sql)
File "C:/Users/peri/.qgis/python/plugins\\db_manager\\db_plugins\\postgis\\connector.py", line 670, in _execute
raise DbError(e, sql)
DbError: missing FROM-clause entry for table "geo”
LINE3: CASE WHEN geo.r_column IS NOT NULL THEN geo.r_column E...

A

Query:

SELECT

cla.relname, nsp.nspname, cla.relkind = 'v', pg_get_userbyid(relowner), cla.reltuples, cla.relpages,
CASE WHEN geo.r_column IS NOT NULL THEN geo.r_column ELSE att.atthame END,
geo.pixel_types,
geo.scale_x,
geo.scale_y,
geo.out_db,
geo.srid

FROM pg_class AS cla
JOIN pg_namespace AS nsp ON
nsp.oid = cla.relnamespace

JOIN pg_attribute AS att ON

att.attrelid = cla.oid AND

att.atttypid = 'raster"::regtype OR

att.atttypid IN (SELECT oid FROM pg_type WHERE typbasetype="raster'::regtype )

WHERE cla.relkind IN ('V', 'r") AND nspname = 'dbt'
ORDER BY nsp.nspname, cla.relname, att.atthame

Python version:
2.5.2 (r252:60911, Feb 21 2008, 13:11:45) [MSC v.1310 32 bit (Intel)]

QGIS version:
1.8.0-Trunk Trunk, b34f924

Python path: ['C:\\\Users\\\\peri\\.qgis\\\\python\\\\plugins\\\\cswclient', 'C:/OSGeo4W/apps/qgis-dev/./python’,
'C:/Users/peri/.qgis/python’, 'C:/Users/peri/.qgis/python/plugins', 'C:/OSGeo4W/apps/qgis-dev/./python/plugins’,
'C:\\WOSGeodW\\Wapps\\orfeotoolbox\\\\python', 'C:\\W', 'CAWNOSGeo4W\\\bin\\\python25.zip',
'C:\WOSGeodW\\Wapps\\\Python25\WDLLs', 'C:\WOSGeodW\\apps\\\\Python25\\\lib',
'C:\WOSGeodW\\\apps\\WPython25\\lib\Wplat-win', 'C:\WOSGeodW\\\apps\\Python25\\lib\\Wib-tk',
'C:\WOSGeodW\\Wapps\\ggis-devi\\\bin', 'C:\WOSGeo4dW\\\\apps\\\Python25',
'C:\WNOSGeodW\\Wapps\\\Python25\\\lib\\\site-packages', 'C:\\W\OSGeo4W\\\apps\\\Python25\\\lib\\\site-packages\\\\win32',
'C:\\WOSGeodW\\\\apps\\Python25\\Wib\\\site-packages\\\win32\\\lib',
'C:\\WOSGeodW\\\apps\\\\Python25\\\lib\\\\site-packages\\\Pythonwin',
'C:\WNOSGeodW\\Wapps\\\Python25\\\lib\\\site-packages\\\\wx-2.8-msw-unicode’,
'C:\WOSGeodW\\\apps\\\qgis-devi\\\python\\\plugins\\f Tools\\\\tools']

| use qgis-dev b34f924 on postgres 9.1.1 and ostgis 2.0 on windows7

History

#1 - 2011-11-08 02:51 PM - Giuseppe Sucameli

- Resolution set to invalid

- Assignee changed from pcavallini - to Giuseppe Sucameli
- Status changed from Open to Closed

DB Manager plugin is not a core QuantumGIS python plugin so this isn't the right place to open tickets.

| planned to move it to QGis Redmine trac soon, but in this moment you have to send errors directly to the maintainer (it's me) or to qgis ML.
